module dices

import StdEnv, monad

prng :: Int -> [Int]
prng seed 
	# seed = 8253729 * seed + 2396403
	= [seed rem 32767: prng seed]

prns = prng 5323

:: PRNs :== [Int]

draw :: PRNs -> (Int, PRNs)
draw prns = (hd prns,tl prns)

dice :: PRNs -> (Int,PRNs)
dice s = (1+i rem 6,s`) where (i,s`) = draw s

diceS :: State PRNs Int
diceS = (\r.1 + r rem 6) <$> S draw

:: State s a = S (s -> (a,s))

unS :: (State s a) -> s -> (a,s)
unS (S f) = f

instance Functor (State s) where
	fmap f (S g) = S (\s.let (a,s`) = g s in (f a,s`))
instance Applicative (State s) where
	pure a = S \s.(a,s)
	(<*>) (S f) (S x) = S \s.let (f1,s1) = f s; (x1,s2) = x s1 in (f1 x1,s2)

clumsyTwoDices :: PRNs -> (Int,PRNs)
clumsyTwoDices s
	# (i,s) = dice s
  # (j,s) = dice s
  = (i+j,s)

twoDices :: State PRNs Int
twoDices = (+) <$> diceS <*> diceS

Start1 = fst (clumsyTwoDices prns)
Start = fst ((unS twoDices) prns)


