module listMonad

import StdEnv, monad

instance Functor [] where
	fmap f l = [f x \\ x <- l]

instance Applicative [] where
	pure x = [x]
	(<*>) fs xs = [f x \\ f <- fs, x <- xs]

instance Monad [] where
	bind xs f = [y \\ x <- xs, y <- f x]

instance fail [] where fail = []

// ---

pairs
	= pure (\x y.(x,y))
	<*> [1,3..9]
	<*> [2,4..8]

triples
	=       [1..]
	>>= \z. [1..z]
	>>= \y. [1..y]
	>>= \x. if (x^2 + y^2 == z^2) (pure (x,y,z)) fail

triples2
	=       [1..]
	>>= \z. [1..z]
	>>= \y. [1..y]
	>>= \x. guard (x^2 + y^2 == z^2) 
	>>| rtrn (x,y,z)

tuples3
	= (\x y z.(x,y,z))
	<$> [1..4]
	<*> ['a'..'d']
	<*> [True,False]

tuples4
	=   [inc, dec] <*> [0,7]

Start = (take 5 triples, take 5 tuples3, tuples4)

