module maybeMonad

import StdEnv, StdMaybe, monad

instance Functor Maybe where
	fmap f (Just x) = Just (f x)
	fmap f Nothing  = Nothing

instance Applicative Maybe where
	pure x = Just x
	(<*>) (Just f) (Just x) = Just (f x)
	(<*>) _        _        = Nothing

instance Monad Maybe where
	bind (Just x) f = f x
	bind _        _ = Nothing

instance fail Maybe where
	fail = Nothing

//instance + (Maybe a) | + a where
//	(+) x y = (+) <$> x <*> y

instance + (f a) | + a & Applicative f where
	(+) x y = (+) <$> x <*> y

instance * (f a) | * a & Applicative f where
	(*) x y = pure (*) <*> x <*> y

instance - (Maybe a) | - a where
	(-) x y = (-) <$> x <*> y

instance / (m a) | /,==,zero a & fail, Monad m  where
	(/) x y = (/) <$> x <*> y >>= \b.guard (b <> zero) >>| pure b
/*	(/) (Just a) (Just b) | b == zero
		= Nothing
		= Just (a/b)
	(/) _ _ = Nothing
*/
instance ~ (Maybe a) | ~ a where
	~ x = fmap ~ x

instance one (f a) | one a & Applicative f where
	one = pure one

instance OrMonad Maybe where
	(<|>) Nothing y = y
	(<|>) x y = x

instance sqrt (m a) | sqrt,Ord,zero a & Monad,fail m where
	sqrt x = sqrt <$> x >>= \a.guard (a >= zero) >>| pure a
//instance sqrt (Maybe a) | sqrt, Ord, zero a where
//	sqrt x = sqrt <$> x >>= \a.guard (a >= zero) >>| pure a
/*	sqrt (Just a) | a >= zero
		= Just (sqrt a)
		= Nothing
	sqrt _ = Nothing
*/
abc :: x x x -> [Maybe Real] | toReal x
abc a b c 
	# a = pure (toReal a)
	# b = pure (toReal b)
	# c = pure (toReal c)
	# det = b * b - a * c * pure 4.0
	= [(~b + sqrt det) / (pure 2.0 * a),(~b - sqrt det) / (pure 2.0 * a)]

abc2 :: x x x -> Maybe [Real] | toReal x
abc2 a b c
	=      pure (toReal a)
	>>= \a.pure (toReal b)
	>>= \b.pure (toReal c)
	>>= \c.pure (b * b - a * c * 4.0)
	>>= \d.guard (a <> 0.0) 
			>>| (guard (d > 0.0)
			>>| pure [(~b + sqrt d) / (2.0 * a),(~b - sqrt d) / (2.0 * a)]
			<|> guard (d == 0.0)
			>>| pure [~b / (2.0 * a)])
//			<|> pure [])
//	<|> pure []

abc2` :: x x x -> Maybe [Real] | toReal x
abc2` a b c
	=      pure (toReal a)
	>>= \a.pure (toReal b)
	>>= \b.pure (toReal c)
	>>= \c.pure (b * b - a * c * 4.0)
	>>= \d.guard (a <> 0.0) 
			>>| (guard (d > 0.0)
			>>| pure [(~b + sqrt d) / (2.0 * a),(~b - sqrt d) / (2.0 * a)]
			<|> guard (d == 0.0)
			>>| pure [~b / (2.0 * a)]
			<|> pure [])
	<|> pure []

Start = (abc2` 8 20 -28, abc2` 1 -2 1, abc2` 8 20 28, abc2` 0 0 0)
