module skeleton5

/*
	Pieter Koopman, pieter@cs.ru.nl
	Advanced Programming.
	Skeleton for assignment 5.
	* To be used in a project with the environment iTasks.
	* The executable must be inside the iTask-SDK directory of the Clean distribution, 
	  or one of its subdirectories. You can either put your program there, or use the
	  set executable option of the Project Options.
	* You can also use the -sdk commandline flag to set the path.
	  Example: -sdk C:\Users\johndoe\Desktop\Clean2.4\iTasks-SDK

*/

import iTasks
import StdArray // for the size of a String

:: Idea	:== String
:: Name	:== String

:: NamedIdea = {name :: Name, idea :: Idea}

derive class iTask NamedIdea

doIdentified :: (Name -> Task x) -> Task x | iTask x
doIdentified task
	=   enterInformation "Enter your name" []
	>>= task // >>= for sequential composition of tasks

editIdea :: Name -> Task NamedIdea
editIdea name
	=           enterInformation (name +++ " add your idea") []
	>>= \idea . return {name = name, idea = idea}

mainTask =   doIdentified editIdea
		 >>= viewInformation "The result" []

Start :: *World -> *World
Start world = startEngine mainTask world
